// Trecho de cdigo ATMega8 - Prj2
//
// Adolfo Bauchspiess
// ENE-UnB CDig 2/2007

unsigned int seno[32] = {383,457,529,595,653,701,736,758,766,758,736,701,653,595,529,457,383,308,236,170,112, 64, 29,  7,  0,  7, 29, 64,112,170,236,308};
unsigned int cont_seno=0;
unsigned int cont_s=0;


/****************************************************************************************************
*** Variveiss: 
****************************************************************************************************/
float y,uk=0,uk_1=0,ek=0,ek_1=0,T=1, uIk, uIk_1=0;
float Kp=0,Kd=0, Ki=0;   
unsigned int segundos=0,count=61,ui,uic,yi,wi, flag_Nsat=1, ref=40;

// Rotina de interrupo chamada pelo overflow do timer0
SIGNAL(SIG_OVERFLOW0) {


	if (count-- ==0) {  // S executa a cada vinte interrupes de overflow do timer 0
		
		yi=read_ADC_10bits(0);   // l temperatura do LM35 via AmpOp; 45C -> Ponto de Operao
		y=0.09964920*yi;	 // 5V/1024bits / 10mv/C   1/4,9 - ganho AmpOp
				
		// controladr PID AntiWindup
		ek=ref-y;   

		if (segundos <= 600) uIk=uIk_1 + ek;  			// canal integral normal
		else uIk=uIk_1 + flag_Nsat*ek;  			// canal integral + Anti-Windup
			
		uk = Kp*ek + Kd*ek_1 + Ki*uIk;  			// PID discreto
		
		ek_1=ek; uk_1=uk; uIk_1=uIk; 				// Atualiza valores em memria
		
		flag_Nsat=1;						// Flag que indica no saturao
		if (uk>1023) { uk=1023; flag_Nsat=0;} 			// Verifica saturao do atuador
			else if (uk<0) {uk=0; flag_Nsat=0;}								

		ui = ~(unsigned int) uk; 		// ~ Inverso do transistor BC548 - Depende do modo PWM
		OCR1AH = (0x0300&ui)>>8; OCR1AL = 0x00ff&ui;		// Reprograma PWM via BC548 (inverso) 
		
		
		if (segundos <= 1200) wi= 0; else wi= seno[cont_seno];  // por enquanto gerador da perturbao - Sensor de RPM?

		printf("%u\t%u\t%u\n\r",yi,(unsigned int)uk,wi);  	// escreve yi, ui e wi na porta serial RS232C
		//printf("%u\n\r",yi); 					// escreve apenas a temperatura 

		PORTB ^= _BV(PB0);  // Sinal de vida - TXData - alterna LED vermelho a cada transmisso (1 segundo) 
		count=61;   						// clockIO/1024/256/61  = 1.0006 Hz
		
		if (segundos++ > 1200) {  // Perturbao senoidal a partir de 20 minutos
		// Perturbao senoidal em PWM2
			if (cont_s-- == 0) {
				OCR1BH = (0x0300&seno[cont_seno])>>8; OCR1BL = 0x00ff&seno[cont_seno];// Reprograma PWM via BC548 
				if (++cont_seno % 32 == 0) cont_seno=0;
				cont_s=2;
			}
		}
		
	}
}


/****************************************************************************************************
*** main: 
****************************************************************************************************/

int main(void){
char str[80];

	/* Define PORTB.0 como sada - Led "sinal de vida" - pisca a cada 2 segundos (on-off)*/
	DDRB = _BV(DDB0)|_BV(DDB5);
	PORTB ^= _BV(PB0);  // Sinal de vida - alterna LED a cada segundo 
	PORTB ^= _BV(PB5);
	PORTB ^= _BV(PB5);
		
	// Programa o timer0 para gerar interrupes peridicas
	TCCR0 = _BV(CS02) | _BV(CS00); // clkIO/1024 (From prescaler)
	TIMSK |= _BV(TOIE0); 			// Timer 0 Overflow Interrupt Enable
	sei(); // habilitacao global das interrupcoes
	
	AD_Iniciar(0);
	PWM_Iniciar();
	
	USART_Init();
	/*registrando as funes de leitura e escrita de um byte pela serial*/
	fdevopen(USART_Transmit, USART_Receive, 0);
	
	while(1) { 
		scanf("%s\n",str); 			// Le a porta serial
		ref = atoi(str);
		PORTB ^= _BV(PB5);// Sinal de vida - RXData - alterna LED Verde a cada recepo (1 segundo)
	} 
}

